#pragma once

// C++ system level
#include <set>
// #include <cstring>     // memset, strncmp
// #include <cstdlib>     // TODO: is this for memcpy?
#include <cinttypes>
// #include <functional>

// ESP32 specific
// #include "esp_err.h"
#include "esp_log.h"
// #include "driver/gpio.h"
// #include "driver/uart.h"

// project specific
// #include ""

// qthing stuff
// #include <qthing>


namespace SiliconTorch {

  namespace NVSExplorer {


    extern const char* TAG;


    class NVSExplorer {

      public:

        void BullShit();


        std::set<std::string> listNamespaces();
        std::set<std::string> listKeys(std::string& _namespace);


        // ⬇⬇ Singleton stuff ⬇⬇

        static NVSExplorer& instance() {
          static NVSExplorer _instance;
          return _instance;
        }

        NVSExplorer(NVSExplorer const&)    = delete;
        void operator=(NVSExplorer const&) = delete;

        // ⬆⬆ Singleton stuff ⬆⬆

      private:

        NVSExplorer();



    };


    std::string toString(std::set<std::string>& set, std::string delimiter = " ");


  }
}
